<?php

declare(strict_types=1);

/**
 * This file is part of the EaseHtml package
 *
 * https://github.com/VitexSoftware/php-ease-html
 *
 * (c) Vítězslav Dvořák <http://vitexsoftware.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Test\Ease\Html;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2016-01-17 at 23:58:52.
 */
class BodyTagTest extends PairTagTest
{
    public string $rendered = '<body></body>';
    public string $renderedEmpty = '<body></body>';
    public string $renderedWithJS = <<<'EOD'
<body>

<script>
// <![CDATA[
alert("Document");
// ]]>
</script>


<script>
// <![CDATA[
$(document).ready(function () { alert("hallo"); });
// ]]>
</script>
</body>
EOD;
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp(): void
    {
        \Ease\WebPage::singleton()->cascadeStyles = [];
        \Ease\Document::singleton()->javaScripts = [];
        $this->object = new \Ease\Html\BodyTag();
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown(): void
    {
    }

    /**
     * @covers \Ease\Html\BodyTag::__construct
     */
    public function testConstructor(): void
    {
        parent::testConstructor();
    }

    /**
     * @covers \Ease\Html\BodyTag::drawIfNotDrawn
     *
     * @param mixed $canBeEmpty
     */
    public function testDrawIfNotDrawn($canBeEmpty = false): void
    {
        $this->rendered = '<body></body>';
        $this->object->emptyContents();
        \Ease\WebPage::clearJavaScriptsCache();
        \Ease\WebPage::clearCascadeStylesCache();
        parent::testDrawIfNotDrawn($canBeEmpty);
    }

    /**
     * @covers \Ease\Html\BodyTag::draw
     *
     * @param null|mixed $whatWant
     */
    public function testDraw($whatWant = null): void
    {
        $this->rendered = '<body></body>';
        $this->object->emptyContents();
        \Ease\WebPage::clearJavaScriptsCache();
        \Ease\WebPage::clearCascadeStylesCache();
        parent::testDraw($whatWant);
    }

    /**
     * @covers \Ease\Html\BodyTag::setObjectName
     */
    public function testSetObjectName(): void
    {
        $this->object->setObjectName();
        $this->assertEquals('body', $this->object->getObjectName());
    }
}
