<?php

declare(strict_types=1);

/**
 * This file is part of the EaseHtml package
 *
 * https://github.com/VitexSoftware/php-ease-html
 *
 * (c) Vítězslav Dvořák <http://vitexsoftware.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Test\Ease\Html;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2016-01-17 at 23:58:56.
 */
class InputRadioTagTest extends InputTagTest
{
    public string $rendered = '<input name="choose" value="test" type="radio" />';
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp(): void
    {
        $this->object = new \Ease\Html\InputRadioTag('choose', 'test');
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown(): void
    {
    }

    /**
     * @covers \Ease\Html\InputRadioTag::__construct
     */
    public function testConstructor(): void
    {
        $classname = \get_class($this->object);

        // Get mock, without the constructor being called
        $mock = $this->getMockBuilder($classname)
            ->disableOriginalConstructor()
            ->getMockForAbstractClass();

        $mock->__construct('Tag', 'test', ['name' => 'Tag', 'id' => 'testing']);

        $this->assertEquals(
            '<input name="Tag" value="test" id="testing" type="radio" />',
            $mock->getRendered(),
        );
    }

    /**
     * @covers \Ease\Html\InputRadioTag::setValue
     *
     * @todo   Implement testSetValue().
     */
    public function testSetValue(): void
    {
        $this->object->setValue('test');
        $this->assertEquals(
            '<input name="choose" value="test" type="radio" checked />',
            $this->object->getRendered(),
        );
    }

    /**
     * @covers \Ease\Html\InputRadioTag::draw
     *
     * @param null|mixed $whatWant
     */
    public function testDraw($whatWant = null): void
    {
        parent::testDraw($this->rendered);
    }
}
